package	jp.co.sds_corp.ratemixer.fx.filter;

import jp.co.sds_corp.transfer.ReceiveEvent;
import jp.co.sds_corp.util.config.IConfiguration;

/**
* 為替レートを通貨ペアと期間のみでフィルタリングします。
XMLは以下の形式です。
<PRE>
&lt;filter class="jp.co.sds_corp.ratemixer.fx.filter.RangeFilter"&gt;
    &lt;target ccy1="USD" ccy2="JPY" term="SP"/&gt;
    &lt;target ccy1="EUR" ccy2="JPY" exclude="true"/&gt;
&lt;/filter&gt;
</PRE>
*/
public class SimpleFxFilter extends FxFilter
{
	private static final long serialVersionUID = 1L;

	/**
	* 指定された初期情報で初期化します。
	* @param	config	初期情報
	*/
	public void init( IConfiguration config ) throws Exception {
		super.init( config );
	}

	/**
	* レートのフィルタリングを行なう
	* @param	ev		レート変更イベント
	*/
	public boolean isValid( ReceiveEvent ev ) throws Exception {
		return true;
	}
}
