package	jp.co.sds_corp.ratemixer.fx.layout;

import jp.co.sds_corp.transfer.layout.FormatParser;
import jp.co.sds_corp.transfer.layout.PatternLayout;

/**
* 指定されたフォーマット文字列を元に、レートを編集します。
フォーマット文字列は以下の指定が可能です。
<TABLE BORDER=1 WIDTH=80%>
<TR>
	<TD>変換文字</TD>
	<TD>編集内容</TD>
	<TD>フォーマット文字列（例）</TD>
</TR>
<TR>
	<TD>C</TD><TD>通貨1</TD><TD>(なし)</TD>
</TR>
<TR>
	<TD>c</TD><TD>通貨2</TD><TD>(なし)</TD>
</TR>
<TR>
	<TD>T</TD><TD>期間</TD><TD>(なし)</TD>
</TR>
<TR>
	<TD>d</TD><TD>現在時刻</TD><TD>yyyy/MM/dd HH:mm:ss</TD>
</TR>
<TR>
	<TD>U</TD><TD>更新日時</TD><TD>yyyy/MM/dd HH:mm:ss</TD>
</TR>
<TR>
	<TD>B</TD><TD>bid rate</TD><TD>0.0000</TD>
</TR>
<TR>
	<TD>A</TD><TD>ask rate</TD><TD>0.0000</TD>
</TR>
<TR>
	<TD>M</TD><TD>mid rate</TD><TD>0.0000</TD>
</TR>
</TABLE>
*/
public class FxPatternLayout extends PatternLayout
{
	/**
	* {@link FormatParser}を生成します。
	* @param	fmt		フォーマット文字列
	*/
	public FormatParser createParser( String fmt ) {
		return new FxFormatParser( fmt );
	}

}
