package	jp.co.sds_corp.ratemixer.fx.source;

import java.io.OutputStream;
import java.io.StringReader;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import javax.swing.text.MutableAttributeSet;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.parser.ParserDelegator;

import jp.co.sds_corp.ratemixer.fx.FxRate;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

/**
* M*neyGardenから、HTTP経由で為替レートを取得します。
*/
public class MoneyGarden extends HttpSource
{
	private static final long serialVersionUID = 1L;
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	List<String> listTbl = new ArrayList<String>();
	String[]	spair = { "EURUSD", "USDJPY", "GBPUSD", "USDCHF", "AUDUSD", "USDCAD", "EURJPY" };
	String term = "SP";
	ParserDelegator parser;
	ParseCallback cb;

	public void init( IConfiguration config ) throws Exception {
		super.init( config );
		parser = new ParserDelegator();
		cb = new ParseCallback();
	}

	public void analyze( String res ) throws Exception {
		StringReader sr = new StringReader( res );
		listTbl.clear();
		parser.parse( sr, cb, true );
		getRatesFromBuffer();
	}

	public void sendRequest( OutputStream os ) {
	}

	class ParseCallback extends HTMLEditorKit.ParserCallback {
		boolean	bStart = false;
		public void handleStartTag(HTML.Tag t, MutableAttributeSet a, int pos) {
			if ( t.toString().equals( "table" ) ) {
				bStart = true;
			}
		}
		public void handleText( char[] data, int pos ) {
			if ( !bStart ) {
				return;
			}
			String sdat = new String( data );
			listTbl.add( sdat );
		}
	}

	private void getRatesFromBuffer() throws Exception {
		FxRate	tmp;
		for ( int i = 0; i < nRates; i++ ) {
			String tbl = listTbl.get( i );
			String tbl8 = listTbl.get( i + 8 );
			String key = tbl + term;
			FxRate rate = (FxRate )getRateMap().get( key );
			if ( rate == null ) {
				continue;
			}
			logger.debug( "["+key+":" + tbl + term + tbl8 );
			String[] res = tbl8.split( " " );
			String sBid = res[0];
			String sAsk = sBid.substring( 0, sBid.length()-2 ).concat( res[2] );
			BigDecimal bid, ask;
			try {
				bid = new BigDecimal( sBid );
				ask = new BigDecimal( sAsk );
			} catch ( Exception ex ) {
				continue;
			}
			tmp = new FxRate( (FxRate )rate );
			tmp.setBid( bid );
			tmp.setAsk( ask );

			if ( !rate.isInit() ) {
			} else {
				rate.setInit( false );
			}
			fireReceive( tmp );
			getRateMap().put( key, tmp );
		}
	}

}
